#bin/bash
#this script copies referemce test results to a *.old files
#runs a driver_1* test from
#its install directory,
#comparing output to references
#in this folder
# NOTE THAT A LIBRARY MUST BE INSTALLED TO EFFECTIVELY
# TEST IT
# run ./quickstart.sh in the main directory
# to install what you need
#
echo '~~~test_solve_from_reference file~~~' >> ../testing.summary
echo '' >> ../testing.summary
echo 'using libkrylov/src/cmplx_sp_test/driver1a_cmplx_sp'  >> ../testing.summary
echo 'on reference matrix problem found in'  >> ../testing.summary
echo ' libkrylov/test/cmplx_sp_ref/ref_1a/cmplx_sp_1a_prob.json' >> ../testing.summary
echo 'Exact Lagrangian:    221.209183' >> ../testing.summary
echo '' >> ../testing.summary
rm cmplx_sp_1a_vals.json 2>/dev/null
rm cmplx_sp_1a_vecs.json 2>/dev/null
mv cmplx_sp_npc_driver1a.out cmplx_sp_npc_driver1a.out.old 2>/dev/null
echo 'solve reference problem with no preconditioner' >> ../testing.summary
echo 'test output in' >> ../testing.summary
echo 'test/cmplx_sp_testing.results/ref_1a/cmplx_sp_npc_driver1a.out' >> ../testing.summary
../../../src/cmplx_sp_test/driver1a_cmplx_sp -precon none > cmplx_sp_npc_driver1a.out
mv cmplx_sp_1a_vals.json cmplx_sp_1a_npc_vals.json
mv cmplx_sp_1a_vecs.json cmplx_sp_1a_npc_vecs.json
grep 'Converged' cmplx_sp_npc_driver1a.out >> ../testing.summary
grep 'Final L' cmplx_sp_npc_driver1a.out >> ../testing.summary
echo 'error statments:' >> ../testing.summary
grep 'failed' cmplx_sp_npc_driver1a.out >> ../testing.summary
echo '' >> ../testing.summary
mv cmplx_sp_apc_driver1a.out cmplx_sp_apc_driver1a.out.old 2>/dev/null
echo 'solve reference problem with approximate spectra preconditioner' >> ../testing.summary
echo 'test output in' >> ../testing.summary
echo 'test/cmplx_sp_testing.results/ref_1a/cmplx_sp_apc_driver1a.out' >> ../testing.summary
../../../src/cmplx_sp_test/driver1a_cmplx_sp -precon conjugate_gradient > cmplx_sp_apc_driver1a.out
mv cmplx_sp_1a_vals.json cmplx_sp_1a_apc_vals.json
mv cmplx_sp_1a_vecs.json cmplx_sp_1a_apc_vecs.json
grep 'Converged' cmplx_sp_apc_driver1a.out >> ../testing.summary
grep 'Final L' cmplx_sp_apc_driver1a.out >> ../testing.summary
echo 'error statments:' >> ../testing.summary
grep 'failed' cmplx_sp_apc_driver1a.out >> ../testing.summary
echo '' >> ../testing.summary
mv cmplx_sp_dpc_driver1a.out cmplx_sp_dpc_driver1a.out.old 2>/dev/null
echo 'solve reference problem with davidson preconditioner' >> ../testing.summary
echo 'test output in' >> ../testing.summary
echo 'test/cmplx_sp_testing.results/ref_1a/cmplx_sp_dpc_driver1a.out' >> ../testing.summary
../../../src/cmplx_sp_test/driver1a_cmplx_sp -precon davidson > cmplx_sp_dpc_driver1a.out
mv cmplx_sp_1a_vals.json cmplx_sp_1a_dpc_vals.json
mv cmplx_sp_1a_vecs.json cmplx_sp_1a_dpc_vecs.json
grep 'Converged' cmplx_sp_dpc_driver1a.out >> ../testing.summary
grep 'Final L' cmplx_sp_dpc_driver1a.out >> ../testing.summary
echo 'error statments:' >> ../testing.summary
grep 'failed' cmplx_sp_dpc_driver1a.out >> ../testing.summary
echo '' >> ../testing.summary
mv cmplx_sp_spc_driver1a.out cmplx_sp_spc_driver1a.out.old 2>/dev/null
echo 'solve reference problem with Jacobi-Davidson preconditioner' >> ../testing.summary
echo 'test output in' >> ../testing.summary
echo 'test/cmplx_sp_testing.results/ref_1a/cmplx_sp_spc_driver1a.out' >> ../testing.summary
../../../src/cmplx_sp_test/driver1a_cmplx_sp -precon sleijpen > cmplx_sp_spc_driver1a.out
mv cmplx_sp_1a_vals.json cmplx_sp_1a_spc_vals.json
mv cmplx_sp_1a_vecs.json cmplx_sp_1a_spc_vecs.json
grep 'Converged' cmplx_sp_spc_driver1a.out >> ../testing.summary
grep 'Final L' cmplx_sp_spc_driver1a.out >> ../testing.summary
echo 'error statments:' >> ../testing.summary
grep 'failed' cmplx_sp_spc_driver1a.out >> ../testing.summary
echo '' >> ../testing.summary
echo '~~~~~Complex Single reference_a tests done~~~~~'
