#bin/bash
#this script copies referemce test results to a *.old files
#runs a driver_1* test from
#its install directory,
#comparing output to references
#in this folder
# NOTE THAT A LIBRARY MUST BE INSTALLED TO EFFECTIVELY
# TEST IT
# run ./quickstart.sh in the main directory
# to install what you need
#
echo '~~~test_solve_from_reference file~~~' >> ../testing.summary
echo '' >> ../testing.summary
echo 'using libkrylov/src/real_sp_test/driver1b_real_sp'  >> ../testing.summary
echo 'on random matrix problem and'  >> ../testing.summary
echo 'with right hand side (rhs) in'  >> ../testing.summary
echo ' libkrylov/src/real_sp_ref/ref_1b/' >> ../testing.summary
echo 'at zero frequency'  >> ../testing.summary
echo 'Exact Lagrangian:   -3.71518210E-02' >> ../testing.summary
echo '' >> ../testing.summary
rm real_sp_1b_vecs.json 2>/dev/null
mv real_sp_npc_driver1b.out real_sp_npc_driver1b.out.old 2>/dev/null
echo 'solve reference problem with no preconditioner' >> ../testing.summary
echo 'test output in' >> ../testing.summary
echo 'test/real_sp_testing.results/ref_1b/real_sp_npc_driver1b.out' >> ../testing.summary
../../../src/real_sp_test/driver1b_real_sp -precon none > real_sp_npc_driver1b.out
mv real_sp_1b_vecs.json real_sp_1b_npc_vecs.json
grep 'Converged' real_sp_npc_driver1b.out >> ../testing.summary
grep 'Final L' real_sp_npc_driver1b.out >> ../testing.summary
echo 'error statments:' >> ../testing.summary
grep 'failed' real_sp_npc_driver1b.out >> ../testing.summary
echo '' >> ../testing.summary
mv real_sp_apc_driver1b.out real_sp_apc_driver1b.out.old 2>/dev/null
echo 'solve reference problem with approximate spectra preconditioner' >> ../testing.summary
echo 'test output in' >> ../testing.summary
echo 'test/real_sp_testing.results/ref_1b/real_sp_apc_driver1b.out' >> ../testing.summary
../../../src/real_sp_test/driver1b_real_sp -precon conjugate_gradient > real_sp_apc_driver1b.out
mv real_sp_1b_vecs.json real_sp_1b_apc_vecs.json
grep 'Converged' real_sp_apc_driver1b.out >> ../testing.summary
grep 'Final L' real_sp_apc_driver1b.out >> ../testing.summary
echo 'error statments:' >> ../testing.summary
grep 'failed' real_sp_apc_driver1b.out >> ../testing.summary
echo '' >> ../testing.summary
mv real_sp_spc_driver1b.out real_sp_spc_driver1b.out.old 2>/dev/null
echo 'solve reference problem with Jacobi-Davidson preconditioner' >> ../testing.summary
echo 'test output in' >> ../testing.summary
echo 'test/real_sp_testing.results/ref_1b/real_sp_spc_driver1b.out' >> ../testing.summary
../../../src/real_sp_test/driver1b_real_sp -precon sleijpen > real_sp_spc_driver1b.out
mv real_sp_1b_vecs.json real_sp_1b_spc_vecs.json
grep 'Converged' real_sp_spc_driver1b.out >> ../testing.summary
grep 'Final L' real_sp_spc_driver1b.out >> ../testing.summary
echo 'error statments:' >> ../testing.summary
grep 'failed' real_sp_spc_driver1b.out >> ../testing.summary
echo '' >> ../testing.summary
echo '~~~~~Real Single reference_b test done~~~~~'
